<?php

//////////
///
///   auth.inc.php
///
//////////

require_once('lib/commons.inc.php');



/*************\
*   METHODS   *
\*************/

$dm['auth.login']   = array('func'   => 'auth_login',
                            'perm'   => AL_NONE,
                            'escape' => true);

$dm['auth.refresh'] = array('func'   => 'auth_refresh',
                            'perm'   => AL_ADMN | AL_SERV | AL_TECH | AL_VIEW,
                            'escape' => false);

$dm['auth.logout']  = array('func'   => 'auth_logout',
                            'perm'   => AL_ADMN | AL_SERV | AL_TECH | AL_VIEW,
                            'escape' => false);



/***************\
*   FUNCTIONS   *
\***************/

function auth_login($user, $pass)
{
   $sql  = "SELECT `user_id`, ";
   $sql .=        "`user`, ";
   $sql .=        "`desc`, ";
   $sql .=        "`level` ";
   $sql .= "FROM `user` ";
   $sql .= "WHERE (`user` = '$user') AND ";
   $sql .=       "(`pass` = SHA1('$pass'))";

   $ret = db_query($sql);

   if(!is_success($ret)) {
      return $ret;
   } else if($ret['payload'] === false) {
      return error('auth', 'failed');
   }

   $ret = $ret['payload'][0];

   ($ret->level & AL_ADMN) && $ret->levelarray[] = 'ADMN';
   ($ret->level & AL_SERV) && $ret->levelarray[] = 'SERV';
   ($ret->level & AL_TECH) && $ret->levelarray[] = 'TECH';
   ($ret->level & AL_VIEW) && $ret->levelarray[] = 'VIEW';

   if($ret->level & (AL_ADMN | AL_TECH | AL_VIEW)) {
      takeover($ret->user_id);
   }

   $_SESSION['authuserid'] = $ret->user_id;
   $_SESSION['authuser'] = $ret->user;
   $_SESSION['authlevel'] = $ret->level;

   setaccess($ret->user_id);

   trace('auth.login', "user={$ret->user}({$ret->user_id}), level=".implode(',', $ret->levelarray), $ret->user_id, 0, 0, 0, 0);

   unset($ret->user_id);
   unset($ret->user);
   unset($ret->level);

   return success($ret);
}

function auth_refresh()
{
   if($_SESSION['authlevel'] & (AL_TECH | AL_VIEW)) {
      setaccess($_SESSION['authuserid']);
   }

   return success(true);
}

function auth_logout()
{
   trace('auth.logout', "user={$_SESSION['authuser']}({$_SESSION['authuserid']})", $_SESSION['authuserid'], 0, 0, 0, 0);

   $sql  = "DELETE FROM `session` ";
   $sql .= "WHERE `user_id` = '".$_SESSION['authuserid']."'";

   session_destroy();

   return db_query($sql);
}

?>
