<?php

//////////
///
///   trace.inc.php
///
//////////

require_once('lib/commons.inc.php');



/*************\
*   METHODS   *
\*************/

$dm['trace.get'] = array('func'   => 'trace_get',
                         'perm'   => AL_ADMN,
                         'escape' => true);



/***************\
*   FUNCTIONS   *
\***************/

function trace_get($search, $offset, $count)
{
   settype($offset, 'integer');
   settype($count, 'integer');

   $sql  = "SELECT `trace`.`timestamp` AS `timestamp`, ";
   $sql .=        "`trace`.`user` AS `user`, ";
   $sql .=        "`trace`.`action` AS `action`, ";
   $sql .=        "`trace`.`desc` AS `desc`, ";
   $sql .=        "`trace`.`user_id` AS `user_id`, ";
   $sql .=        "`trace`.`group_id` AS `group_id`, ";
   $sql .=        "`trace`.`activity_id` AS `activity_id`, ";
   $sql .=        "`trace`.`target_id` AS `target_id`, ";
   $sql .=        "`trace`.`backdoor_id` AS `backdoor_id`, ";
   $sql .=        "IFNULL(`user`.`user`, '<deleted>') as `user_name`, ";
   $sql .=        "IFNULL(`group`.`group`, '<deleted>') as `group_name`, ";
   $sql .=        "IFNULL(`activity`.`activity`, '<deleted>') as `activity_name`, ";
   $sql .=        "IFNULL(`target`.`target`, '<deleted>') as `target_name`, ";
   $sql .=        "IFNULL(`backdoor`.`backdoor`, '<deleted>') as `backdoor_name` ";
   $sql .= "FROM `trace` ";
   $sql .= "LEFT JOIN `user` ";
   $sql .= "USING (`user_id`) ";
   $sql .= "LEFT JOIN `group` ";
   $sql .= "USING (`group_id`) ";
   $sql .= "LEFT JOIN `activity` ";
   $sql .= "USING (`activity_id`) ";
   $sql .= "LEFT JOIN `target` ";
   $sql .= "USING (`target_id`) ";
   $sql .= "LEFT JOIN `backdoor` ";
   $sql .= "USING (`backdoor_id`) ";
   $sql .= "WHERE 1 ";
   foreach(array('timestamp') as $field) {
      if(isset($search[$field]) && is_array($search[$field])) {
         $sql .= "AND (0";
         foreach($search[$field] as $s) {
            $sql .= " OR `trace`.`$field` BETWEEN '".str_replace(':', '', $s['begin']->scalar)."' AND '".str_replace(':', '', $s['end']->scalar)."'";
         }
         $sql .= ") ";
      }
   }
   foreach(array('user', 'action', 'desc') as $field) {
      if(isset($search[$field]) && is_array($search[$field])) {
         $sql .= "AND (0";
         foreach($search[$field] as $s) {
            $sql .= " OR `trace`.`$field` LIKE '%".$s."%'";
         }
         $sql .= ") ";
      }
   }
   foreach(array('user_id', 'group_id', 'activity_id', 'target_id', 'backdoor_id') as $field) {
      if(isset($search[$field]) && is_array($search[$field]) && count($search[$field])) {
         $sql .= "AND `trace`.`$field` IN ('".implode("', '", $search[$field])."') ";
      }
   }
   foreach(array('user', 'group', 'activity', 'target', 'backdoor') as $field) {
      if(isset($search[$field]) && is_array($search[$field])) {
         $sql .= "AND (0";
         foreach($search[$field] as $s) {
            $sql .= " OR `$field`.`$field` LIKE '%".$s."%'";
         }
         $sql .= ") ";
      }
   }
   $sql .= "LIMIT $offset, $count";

   $ret = db_query($sql);

   if(!is_success($ret)) {
      return $ret;
   } else if($ret['payload'] === false) {
      return success(array());
   }

   return $ret;
}

?>
